function showCampaignsTable(buttons) {
	$('#content').html('');

	uki({ view: 'VSplitPane', rect: '100 600', anchors: 'top left right bottom', handleWidth: 1, leftMin: 40, rightMin: 600, handlePosition: 40,
		leftChildViews: [
			{ view: 'Box', rect: '0 0 300 300', anchors: 'left top', id: 'button_box', childViews: buttons }
		],
		rightChildViews: [
			{ view: 'Table', rect: '0 0 860 800', minSize: '860 200', anchors: 'left top right bottom', columns: [
				{ view: 'table.CustomColumn', label: 'CampaignID', resizable: true, width: 170 },
				{ view: 'table.CustomColumn', label: 'Date', resizable: true, width: 90 },
				{ view: 'table.CustomColumn', label: 'Name', resizable: true, width: 300 },
				{ view: 'table.CustomColumn', label: 'Description', resizable: true, width: 300 },
			], style: {fontSize: '14px', lineHeight: '14px'}, id: 'table' }
		]
	}).attachTo($('#content')[0], '1000 1000');

	hideLoading();
}

function flattenCampaigns(campaigns) {
	var ret = [];
	for (var i in campaigns)
		ret.push(flattenCampaign(campaigns[i]));
	return ret;
}

function flattenCampaign(campaign) {
	return [ campaign['id'],
		campaign['start'],
		campaign['name'],
		campaign['description'] ];
}

function highlightLink(id) {
	$('.nav_link').removeClass('nav_selected');
	$(id).addClass('nav_selected');
}

function loadExistingCampaigns() {
	highlightLink('#existing_link');

	$('#content').text('Loading...');
	$.ajax('ajax',
		{
			data: {f: 'getSavedCampaigns'},
			success: showExistingCampaigns,
		}
	);
}

function showExistingCampaigns(data, textStatus, xhr) {
	showCampaignsTable([
		{ view: 'Button', rect: '0 0 175 25', text: 'Refresh from Salesforce', id: 'refresh_campaign' },
		{ view: 'Button', rect: '185 0 200 25', text: 'Upload results to Salesforce', id: 'upload_campaign' },
		{ view: 'Button', rect: '395 0 75 25', text: 'Delete', id: 'delete_campaign' },
		{ view: 'Image', rect: '480 4 16 16 ', src: 'images/loading.gif', id: 'loading' },
	]);

	var campaigns = flattenCampaigns(data['campaigns']);
	uki('#table').data(campaigns);

	$('#refresh_campaign').click(function() {
		if (! uki('#table').selectedRow())
			return;

		showLoading();
		$.ajax('ajax',
			{
				data: {f: 'saveCampaign', id: uki('#table').selectedRow()[0]},
				success: function() {
				}
			}
		).always(hideLoading);
	});

	$('#upload_campaign').click(function() {
		if (! uki('#table').selectedRow())
			return;

		showLoading();
		$.ajax('ajax',
			{
				data: {f: 'uploadCampaignResults', id: uki('#table').selectedRow()[0]},
				success: function() {
				}
			}
		).always(hideLoading);
	});

	$('#delete_campaign').click(function() {
		if (! uki('#table').selectedRow())
			return;

		showLoading();
		$.ajax('ajax',
			{
				data: {f: 'deleteCampaign', id: uki('#table').selectedRow()[0]},
				success: function() {
					uki('#table').removeRow(uki('#table').lastClickIndex());
				}
			}
		).always(hideLoading);
	});
}

function loadImportCampaigns() {
	highlightLink('#import_link');

	$('#content').text('Loading...');
	$.ajax('ajax',
		{
			data: {f: 'getNewCampaigns'},
			success: showImportCampaigns,
		}
	);
};

function showImportCampaigns(data, textStatus, xhr) {
	showCampaignsTable([
		{ view: 'Button', rect: '0 0 75 25', text: 'Import', id: 'import_campaign' },
		{ view: 'Image', rect: '85 4 16 16 ', src: 'images/loading.gif', id: 'loading' },
	]);

	var campaigns = flattenCampaigns(data['campaigns']);
	uki('#table').data(campaigns);

	$('#import_campaign').click(function() {
		if (! uki('#table').selectedRow())
			return;

		showLoading();
		$.ajax('ajax',
			{
				data: {f: 'saveCampaign', id: uki('#table').selectedRow()[0]},
				success: function() {
					uki('#table').removeRow(uki('#table').lastClickIndex());
				}
			}
		).always(hideLoading);
	});
}

function showLoading() {
	uki('#loading').visible(true);
}

function hideLoading() {
	uki('#loading').visible(false);
}
